> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/android/profile-data/custom-locale.md).

# Custom region/language

Batch allows you to set a custom region or a custom language that will override the value detected by the SDK. By default, Batch collects the language and the country of your users' devices.

Setting a custom region/language is useful if:

* You don't want to use the values detected by Batch.
* Your users can choose their own language or region for localization purposes.

![Custom locale](/files/SifTDeyDFZyAmSoHdhhk)

**Writing custom region/language**

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
Batch.Profile.editor().apply {
   setLanguage("en") // Language must be 2 chars, lowercase, ISO 639 formatted
   setRegion("US") // Region must be 2 chars, uppercase, ISO 3166 formatted
   save()
}
```

{% endtab %}

{% tab title="Java" %}

```java
Batch.Profile.editor()
    .setLanguage("en") // Language must be 2 chars, lowercase, ISO 639 formatted
    .setRegion("US") // Region must be 2 chars, uppercase, ISO 3166 formatted
    .save();
}
```

{% endtab %}
{% endtabs %}

**Reading custom region/language**

Keep in mind that the data returned is only about your installation and not your Profile since it may be updated from another source.

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
// This is how you retrieve your custom values. Values are nil by default.
val language: String? = Batch.User.getLanguage(context)
val region: String? = Batch.User.getRegion(context)
```

{% endtab %}

{% tab title="Java" %}

```java
// This is how you retrieve your custom values. Values are nil by default.
String language = Batch.User.getLanguage(context);
String region = Batch.User.getRegion(context);
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://doc.batch.com/developer/sdk/android/profile-data/custom-locale.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
